#include "core/Plane.h"

#include "core/Generic.h"

#define CV30 (&VECTOR3)

void initPlane(Plane* p, const Vector3* a, const Vector3* b, const Vector3* c) {
    cross(&p->abc, sub(CV30, b, a), sub(CV30, c, a));
    normalize(&p->abc);
    p->d = -dot(&p->abc, b);
}

float signedDistance(const Plane* p, const Vector3* v) {
    return dot(&p->abc, v) + p->d;
}
